freeslot("SPR_XXXX", "SPR_CMNT", "S_XMARK", "S_COMMENT", "S_COMMENT2", "MT_XMARK", "MT_COMMENT")
mobjinfo[MT_COMMENT] = {
	spawnstate = S_COMMENT,
	flags = MF_SPECIAL|MF_NOGRAVITY,
	radius = 13*FRACUNIT,
	height = 30*FRACUNIT
}
states[S_COMMENT] = {
	sprite = SPR_CMNT,
	frame = FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = -1,
	nextstate = S_NULL
}
states[S_COMMENT2] = {
	sprite = SPR_CMNT,
	frame = FF_PAPERSPRITE|FF_FULLBRIGHT|TR_TRANS40|A,
	tics = -1,
	nextstate = S_NULL
}
mobjinfo[MT_XMARK] = {
	spawnstate = S_XMARK,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}
states[S_XMARK] = {
	sprite = SPR_XXXX,
	frame = FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = -1,
	nextstate = S_NULL
}

local SND_ERROR = sfx_s3kb2
local SND_NEUTRAL = sfx_s3k65
local SND_GOOD = sfx_s245

--printF(player_t player, string str)
--Print for the given player
local function printF(player,str)
	if consoleplayer == player
		print(str)
	end
end

--printD(string str)
--Print for the dedicated server
local function printD(str)
	if isdedicatedserver
		print(str)
	end
end

addHook("MobjThinker", function(mo)
	if mo.spinspeed > ANG2
		mo.spinspeed = max($ - ANG1/2, ANG2)
	end
	if mo.activ > 0
		mo.activ = $ - 1
		if mo.activ == 0
			mo.state = S_COMMENT
		end
	end
	mo.angle = $ + mo.spinspeed;
end, MT_COMMENT)

addHook("MobjThinker", function(mo)
	mo.angle = $ - mo.spinspeed;
end, MT_XMARK)

addHook("TouchSpecial", function(touched, mo)
	if not (mo.player and mo.player.valid) return true end
	
	local player = mo.player
	if touched.activ == 0
		touched.spinspeed = ANG30
		S_StartSound(nil, SND_NEUTRAL, player)
		printF(player, "\x82"..touched.fulltext)
		touched.activ = 130
		touched.state = S_COMMENT2
	end
	return true
end, MT_COMMENT)

addHook("MapLoad", function()
	//Read comment data and place mobjs
	if netgame
		print("\133Please only use this addon in offline games. Use L_Feedback for netgames to record the data first!")
		S_StartSound(nil, SND_ERROR, player)
		return
	end
	local num = 0
	while num < 10
		local file = 0
		if num == 0
			file = io.openlocal("Comments.txt", "r")
		else
			file = io.openlocal("Comments"..num..".txt", "r")
		end
		num = $ + 1
		
		if file
			print("\x87Loading comments and death markers...")
			local commentamt = 0
			while true
				local map = tonumber(file:read())
				if map == nil break end
				
				local intermission = false;
				local cx = tostring(file:read())
				local cy = tostring(file:read())
				local cz = tostring(file:read())
				cx = tonumber(cx)
				cy = tonumber(cy)
				cz = tonumber(cz)
				local fulltext = file:read()
				
				if map == gamemap
					commentamt = $ + 1
					if cx != nil and cy != nil and cz != nil
						local cmo = P_SpawnMobj(cx,cy,cz,MT_COMMENT)
						cmo.fulltext = fulltext
						cmo.destscale = 3*FRACUNIT
						cmo.spinspeed = ANG2 + P_RandomRange(0,30) * ANG1
						cmo.activ = 0
					else
						print("\x82"..fulltext)
					end
				end
			end
			print("\x87Loaded "..commentamt.." comments.")
			S_StartSound(nil, SND_GOOD, player)
		end
	end
	
	num = 0
	while num < 10
		local file = 0
		if num == 0
			file = io.openlocal("Deaths.txt", "r")
		else
			file = io.openlocal("Deaths"..num..".txt", "r")
		end
		num = $ + 1
		
		//Read death data and place mobjs
		if file
			local deathamt = 0
			while true
				local map = tonumber(file:read())
				if map == nil break end
				local cx = tonumber(file:read())
				local cy = tonumber(file:read())
				local cz = tonumber(file:read())
				
				if map == gamemap
					deathamt = $ + 1
					local cmo = P_SpawnMobj(cx,cy,cz,MT_XMARK)
					cmo.destscale = 2*FRACUNIT
					cmo.spinspeed = ANG1 + P_RandomRange(0,20) * ANG1/20
				end
			end
			print("\x87Loaded "..deathamt.." death markers.")
		end
	end
end)